<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::capabilityAgents::notifications::NotificationRendererInterface Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents.html">capabilityAgents</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1notifications.html">notifications</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_interface.html">NotificationRendererInterface</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_interface-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::capabilityAgents::notifications::NotificationRendererInterface Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_notification_renderer_interface_8h_source.html">NotificationRendererInterface.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::capabilityAgents::notifications::NotificationRendererInterface:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_interface__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_interface_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_interface_inherit__map" id="alexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_interface_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html" title="alexaClientSDK::capability\lAgents::notifications::\lNotificationRenderer" alt="" coords="261,5,439,57"/>
<area shape="rect" id="node3" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1test_1_1_mock_notification_renderer.html" title="alexaClientSDK::capability\lAgents::notifications::\ltest::MockNotificationRenderer" alt="" coords="248,81,452,133"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a9ac892338bdc1ae872c059d808221634"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_interface.html#a9ac892338bdc1ae872c059d808221634">~NotificationRendererInterface</a> ()=default</td></tr>
<tr class="separator:a9ac892338bdc1ae872c059d808221634"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a107670d432b9a809ec514d2883811943"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_interface.html#a107670d432b9a809ec514d2883811943">addObserver</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_observer_interface.html">NotificationRendererObserverInterface</a> &gt; observer)=0</td></tr>
<tr class="separator:a107670d432b9a809ec514d2883811943"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afe377f64e4756d13adfd8abcf560c91d"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_interface.html#afe377f64e4756d13adfd8abcf560c91d">removeObserver</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_observer_interface.html">NotificationRendererObserverInterface</a> &gt; observer)=0</td></tr>
<tr class="separator:afe377f64e4756d13adfd8abcf560c91d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abc5288cf255559236950c944df4fef55"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_interface.html#abc5288cf255559236950c944df4fef55">renderNotification</a> (std::function&lt; std::unique_ptr&lt; std::istream &gt;()&gt; audioFactory, const std::string &amp;url)=0</td></tr>
<tr class="separator:abc5288cf255559236950c944df4fef55"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afddf911fa96fd2f19ae06bd3360a34cd"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_interface.html#afddf911fa96fd2f19ae06bd3360a34cd">cancelNotificationRendering</a> ()=0</td></tr>
<tr class="separator:afddf911fa96fd2f19ae06bd3360a34cd"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">Interface to an object that handles rendering notification audio clips. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a9ac892338bdc1ae872c059d808221634"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9ac892338bdc1ae872c059d808221634">&#9670;&nbsp;</a></span>~NotificationRendererInterface()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual alexaClientSDK::capabilityAgents::notifications::NotificationRendererInterface::~NotificationRendererInterface </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a107670d432b9a809ec514d2883811943"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a107670d432b9a809ec514d2883811943">&#9670;&nbsp;</a></span>addObserver()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void alexaClientSDK::capabilityAgents::notifications::NotificationRendererInterface::addObserver </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_observer_interface.html">NotificationRendererObserverInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>observer</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Add an observer to receive a notifications about rendering notification audio clips.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">observer</td><td>The observer to call back. </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1test_1_1_mock_notification_renderer.html#ab9ed8d0acb830755e95f9c925be4d9cd">alexaClientSDK::capabilityAgents::notifications::test::MockNotificationRenderer</a>, and <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#a8c1b7c1018c83e406a041d27eb6bb26d">alexaClientSDK::capabilityAgents::notifications::NotificationRenderer</a>.</p>

</div>
</div>
<a id="afddf911fa96fd2f19ae06bd3360a34cd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afddf911fa96fd2f19ae06bd3360a34cd">&#9670;&nbsp;</a></span>cancelNotificationRendering()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool alexaClientSDK::capabilityAgents::notifications::NotificationRendererInterface::cancelNotificationRendering </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Cancel any ongoing rendering of a notification audio clip. Further render requests will be refused until an observer callback is made to indicate that rendering has finished (i.e. cancellation is complete).</p>
<dl class="section return"><dt>Returns</dt><dd>Whether or not the cancellation was allowed. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1test_1_1_mock_notification_renderer.html#a6c08cafc318b735bf13f720ae24beae9">alexaClientSDK::capabilityAgents::notifications::test::MockNotificationRenderer</a>, and <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#a4f590589d4503fd32ee47fdc1b683b72">alexaClientSDK::capabilityAgents::notifications::NotificationRenderer</a>.</p>

</div>
</div>
<a id="afe377f64e4756d13adfd8abcf560c91d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afe377f64e4756d13adfd8abcf560c91d">&#9670;&nbsp;</a></span>removeObserver()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void alexaClientSDK::capabilityAgents::notifications::NotificationRendererInterface::removeObserver </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_observer_interface.html">NotificationRendererObserverInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>observer</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Remove an observer from the set of observers to receive a notifications about rendering notification audio clips.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">observer</td><td>The observer to call back. </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1test_1_1_mock_notification_renderer.html#a38cf5febc8b088edd683c21fb76f846a">alexaClientSDK::capabilityAgents::notifications::test::MockNotificationRenderer</a>, and <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#aa6b7fa67a467fd23a84feac79fdb9e9f">alexaClientSDK::capabilityAgents::notifications::NotificationRenderer</a>.</p>

</div>
</div>
<a id="abc5288cf255559236950c944df4fef55"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abc5288cf255559236950c944df4fef55">&#9670;&nbsp;</a></span>renderNotification()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool alexaClientSDK::capabilityAgents::notifications::NotificationRendererInterface::renderNotification </td>
          <td>(</td>
          <td class="paramtype">std::function&lt; std::unique_ptr&lt; std::istream &gt;()&gt;&#160;</td>
          <td class="paramname"><em>audioFactory</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>url</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Render (play) a notification audio clip. If the asset at the specified url cannot be played for some reason, the default notification audio clip should be played, instead. If renderNotification is called while another rendering operation is in progress, this method fails and returns false. </p><dl class="section note"><dt>Note</dt><dd>: Calling this method from a <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_observer_interface.html">NotificationRendererObserverInterface</a> callback will lead to a deadlock.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">audioFactory</td><td>A function that produces an audio stream to play if the audio specified by <code>url</code> can not be played. </td></tr>
    <tr><td class="paramname">url</td><td>URL of the preferred audio asset to play. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether rendering the notification was initiated. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1test_1_1_mock_notification_renderer.html#ad838ec7859bb89696ce9a302cf344902">alexaClientSDK::capabilityAgents::notifications::test::MockNotificationRenderer</a>, and <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#ab90f400f6d91e73371bbe8afbf3ced56">alexaClientSDK::capabilityAgents::notifications::NotificationRenderer</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>/workplace/avs-device-sdk/CapabilityAgents/Notifications/include/Notifications/<a class="el" href="_notification_renderer_interface_8h_source.html">NotificationRendererInterface.h</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
